"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var apputils_1 = require("@jupyterlab/apputils");
var coreutils_1 = require("@phosphor/coreutils");
var widgets_1 = require("@phosphor/widgets");
// TODO: there is a lot of extraneous code since this branch doesn't use iframes
var IBGPanel = /** @class */ (function (_super) {
    __extends(IBGPanel, _super);
    function IBGPanel() {
        var _this = _super.call(this) || this;
        _this._frame = new apputils_1.IFrame();
        _this.addWidget(_this._frame);
        return _this;
    }
    Object.defineProperty(IBGPanel.prototype, "iframeNode", {
        get: function () {
            return this.node.querySelector('iframe');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IBGPanel.prototype, "url", {
        get: function () {
            return this._frame.url;
        },
        set: function (url) {
            this._frame.url = url;
        },
        enumerable: true,
        configurable: true
    });
    return IBGPanel;
}(widgets_1.Panel));
exports.IBGPanel = IBGPanel;
var Private;
(function (Private) {
    var counter = 0;
    Private.namespace = 'ibg-ext';
    function createIBGPanel(gateway) {
        var frame = new IBGPanel();
        frame.id = Private.namespace + "-" + ++counter;
        frame.title.label = gateway;
        frame.title.closable = true;
        frame.url = "/" + gateway + "/vnc";
        return frame;
    }
    Private.createIBGPanel = createIBGPanel;
})(Private || (Private = {}));
/**
 * The command IDs used by the launcher plugin.
 */
var CommandIDs;
(function (CommandIDs) {
    CommandIDs.create = 'ibg:create';
})(CommandIDs || (CommandIDs = {}));
/**
 * The editor tracker token.
 */
exports.IBGPanelTracker = new coreutils_1.Token('jupyterlab_quantrocket_ibgui:IBGPanelTracker');
var extension = {
    id: 'jupyterlab_quantrocket_ibgui',
    autoStart: true,
    requires: [apputils_1.ICommandPalette],
    provides: exports.IBGPanelTracker,
    activate: function (app, palette) {
        var tracker = new apputils_1.InstanceTracker({ namespace: Private.namespace });
        app.commands.addCommand(CommandIDs.create, {
            label: 'IB Gateway GUI',
            execute: function (args) {
                var xhr = new XMLHttpRequest();
                xhr.open('GET', '/launchpad/gateways');
                xhr.onload = function () {
                    if (xhr.status == 200) {
                        var gateways = JSON.parse(xhr.responseText);
                        for (var gateway in gateways) {
                            window.open("/" + gateway + "/vnc", '_blank');
                        }
                        return Promise.resolve();
                    }
                    else {
                        alert('Error retrieving list of IB Gateways: ' + xhr.status + ' ' + xhr.responseText);
                    }
                };
                xhr.send();
            }
        });
        palette.addItem({ command: CommandIDs.create, category: 'QuantRocket' });
        return tracker;
    }
};
exports.default = extension;
